Attribute VB_Name = "Module1"
'****************************************************************
'*  Name    : DS1307 MNA 1 .BAS                                 *
'*  Author  : Alain DEVAL  F5MNA                                *
'*  Notice  : Copyright (c) 2011 [Alain DEVAL]                  *
'*          : All Rights Reserved                               *
'*  Date    : 05/02/2011                                        *
'*  Version : 1.0                                               *
'*  Notes   : Programme associ  l'horloge F5MNA DS1307        *
'             http://f5mna.free.fr                              *
'****************************************************************
Device = 16F628
XTAL 4
Declare LCD_LINES 2
ALL_DIGITAL = True
PORTB_PULLUPS = True

' Ports du bus I2C
SDA_Pin = PORTA.3 'DS1307 SDA
SCL_PIN = PORTA.4 'DS1307 SCL

input  porta.2              'rend PORTA.2 input
input  porta.1              'rend PORTA.1 input
input  portA.0              'rend PORTb.3 input
Symbol up=PORTA.2                       'portA.2 pour bouton "up"
Symbol down=PORTA.1                     'portA.1 pour bouton "down"
Symbol Initial=PORTA.0          'portA.3 pour bouton initialisation
 
Dim Temp1 As Byte
Dim Temp2 As Byte
Dim TempVal As Byte
Dim Secs As Byte
Dim Mins As Byte
Dim Hrs As Byte
Dim Day As Byte
DIM Jour[6] AS BYTE
Dim mois[9] as byte
Dim Date As Byte
Dim Month As Byte
Dim Year As Byte
Dim Ctrl As Byte
Dim Secs_last As Byte
'***********************************************
'Pour mise  l'heure
Dim buttonvalue As Byte                 'variable pour les boutons "up" and "down"
Ctrl = 0 ' Byte de contrle laiss ici  0
'Initialisation de l'afficheur LCD
Cls
Delayms 100
 
'PROGRAMME PRINCIPAL*****************
Main:
If initial = 1 Then
    BStart
    ' Lecture du DS1307 : 1101000x avec x = 1 pour lire et 0 pour crire
    BusIn 11010001, 0, [Secs, Mins, Hrs, day, Date, Month, Year, Ctrl]
 
    BStop
    ' Le DS1307 expdie les donnes en BCD. Elles doivent tre changes en BIN
    ' afin de pouvoir tre affiches par le LCD
    
    TempVal = Secs
    GoSub BCD_TO_BIN
    Secs = TempVal
 
    TempVal = Mins
    GoSub BCD_TO_BIN
    Mins = TempVal
 
    TempVal = Hrs
    GoSub BCD_TO_BIN
    Hrs = TempVal
    
    TempVal = Day
    GoSub BCD_TO_BIN
    Day = TempVal
 
    TempVal = Date
    GoSub BCD_TO_BIN
    Date = TempVal
 
    TempVal = Month
    GoSub BCD_TO_BIN
    Month = TempVal
 
    TempVal = Year
    GoSub BCD_TO_BIN
    Year = TempVal
    
    'gestion du jour
    Select Case Day
      Case 1
       Str Jour = "lundi "
      Case 2
       Str Jour = "mardi "
      Case 3
       Str Jour = "mercr."
      Case 4
       Str Jour = "jeudi "
      Case 5
        Str Jour = "vendr."
      Case 6
        Str Jour = "samedi"
      Case 7
        Str Jour = "dim.  "
    End Select
      
   Select Case Month
       Case 1: Str mois = " janvier "
       Case 2: Str mois = " fevrier "
       Case 3: Str mois = " mars    "
       Case 4: Str mois = " avril   "
       Case 5: Str mois = " mai     "
       Case 6: Str mois = " juin    "
       Case 7: Str mois = " juillet "
       Case 8: Str mois = " aout    "
       Case 9: Str mois = " sept.   "
       Case 10: Str mois = " octobre "
       Case 11: Str mois = " novemb. "
       Case 12: Str mois = " decemb. "
     End Select
      
     
    'Mise  jour heure et date
    If Secs - Secs_last = 0 Then GoTo Main
 
    'affichage de l'heure et de la date sur deux caractres (DEC2).
    Print At; 1, 2, Str; Jour, " ", Dec2; Hrs, ":", Dec2; Mins, ":", Dec2; Secs
    Print At; 2, 2, Dec2; Date, Str; mois, "20", Dec2; Year
 
    Secs_last = Secs

  Else
    GoSub Initialis   'Initialisation et Mise  l'heure par bouton init
  End If
  GoTo Main

'***************************************************
'Les deux sous-routines suivantes BCD_to_BIN et BIN_to_BCD proviennent du Net'
BCD_TO_BIN:                    ' Convert the BCD values into BIN
Temp1 = $0F & TempVal          ' Clear off the top four bits
Temp1 = DIG Temp1, 0
Temp2 = TempVal >> 4           ' Shift down four to read 2 BCD value
Temp2 = DIG Temp2, 0
TempVal = Temp2 * 10 + Temp1
Return
 
BIN_TO_BCD:
Temp1 = Dig TempVal, 0         ' GET THE DEC DIGIT FOR THE FIRST NIBBLE
Temp2 = Dig TempVal, 1         ' GET THE DEC DIGIT FOR THE FIRST NIBBLE
Temp2 = Temp2 << 4             ' MOVE NUMBER OVER TO 2ND NIBBLE
' XOR THEM TOGTHER TO MAKE THE WHOLE BCD NUMBER
TempVal = Temp1 ^ Temp2
Return

'******INITIALISATION / MIE A L'HEURE****
Initialis:
 '************HEURE**********************
 Cls
 Delayms 300                                                                     '
 buttonvalue = Hrs
 repeat
       Print At; 1, 1, " Heure:      ", Dec2; Hrs
       If up = 0 Then Inc buttonvalue: Delayms 200  'Si le bouton up = 0 on incrmente de 1 "buttonvalue"
       If buttonvalue > 23 Then buttonvalue = 0         'Si "buttonvalue" dpasse la maximum il devient alors gal  0
       If down = 0 Then dec buttonvalue: Delayms 200 'Si le bouton up = 0 on decrmente de 1 "buttonvalue"
       If buttonvalue < 0 Then buttonvalue = 23         'Si "buttonvalue" infrieur au minimum il devient alors gal 23
       Hrs = buttonvalue
 until initial = 0
 
 '*************MINUTES*********************
  Delayms 300
  buttonvalue = Mins
  repeat
      Print At; 1, 1, " Minute:     ", Dec2; Mins
      If up = 0 Then Inc buttonvalue: Delayms 200     'Si le bouton up = 0 on incrmente de 1 "buttonvalue"
      If buttonvalue > 59 Then buttonvalue = 0            'Si "buttonvalue" dpasse la maximum il devient alors gal  2
      If down = 0 Then dec buttonvalue: Delayms 200   'Si le bouton up = 0 on decrmente de 1 "buttonvalue"
      If buttonvalue < 0 Then buttonvalue = 59        'Si "buttonvalue" infrieur au minimum il devient alors gal  59
      Mins = buttonvalue
   until initial = 0
   
 '********Jour************
   Delayms 300
   buttonvalue = Day
   repeat
       Print At; 1, 1, " Jour:      ", Str; Jour
       If up = 0 Then Inc buttonvalue: Delayms 200  'Si le bouton up = 0 on incrmente de 1 "buttonvalue"
       If buttonvalue > 7 Then buttonvalue = 1  'Si "buttonvalue" dpasse la maximum il devient alors gal  31
       If down = 0 Then dec buttonvalue: Delayms 200 'Si le bouton up = 0 on decrmente de 1 "buttonvalue"
       If buttonvalue < 1 Then buttonvalue = 7  'Si "buttonvalue" infrieur au minimum il devient alors gal  1
       Day = buttonvalue
    select day
      Case 1
       Str Jour = "lun"
      Case 2
       Str Jour = "mar"
      Case 3
       Str Jour = "mer"
      Case 4
       Str Jour = "jeu"
      Case 5
       Str Jour = "ven"
      Case 6
       Str Jour = "sam"
      Case 7
       Str Jour = "dim"
    End Select
   until initial = 0
'********Date************
   Cls
   Delayms 300
   buttonvalue = Date
   repeat
       Print At; 1, 1, " Date:       ", Dec2; Date
       If up = 0 Then Inc buttonvalue: Delayms 200  'Si le bouton up = 0 on incrmente de 1 "buttonvalue"
       If buttonvalue > 31 Then buttonvalue = 1         'Si "buttonvalue" dpasse la maximum il devient alors gal  31
       If down = 0 Then dec buttonvalue: Delayms 200 'Si le bouton up = 0 on decrmente de 1 "buttonvalue"
       If buttonvalue < 1 Then buttonvalue = 31         'Si "buttonvalue" infrieur au minimum il devient alors gal  1
       Date = buttonvalue
   until initial = 0

 '*********MOIS***********
   Cls
   Delayms 300
   buttonvalue = Month
   repeat
       Print At; 1, 1, " Mois:       ", Dec2; Month
       If up = 0 Then Inc buttonvalue: Delayms 200  'Si le bouton up = 0 on incrmente de 1 "buttonvalue"
       If buttonvalue > 12 Then buttonvalue = 1         'Si "buttonvalue" dpasse la maximum il devient alors gal  1
       If down = 0 Then dec buttonvalue: Delayms 200 'Si le bouton up = 0 on decrmente de 1 "buttonvalue"
       If buttonvalue < 1 Then buttonvalue = 12         'Si "buttonvalue" infrieur au minimum il devient alors gal  12
       Month = buttonvalue
   until initial = 0
 
 '*********ANNEE*************
  Cls
  Delayms 300
  buttonvalue = Year
  repeat
       Print At; 1, 1, "  Annee:   ", "20", Dec2; Year
       If up = 0 Then Inc buttonvalue: Delayms 200 'Si le bouton up = 0 on incrmente de 1 "buttonvalue"
       If buttonvalue > 99 Then buttonvalue = 0    'Si "buttonvalue" dpasse la maximum il devient alors gal  0
       If down = 0 Then dec buttonvalue: Delayms 200 'Si le bouton up = 0 on decrmente de 1 "buttonvalue"
       If buttonvalue < 0 Then buttonvalue = 99    'Si "buttonvalue" infrieur au minimum il devient alors gal  99
       Year = buttonvalue
 until initial = 0

 '**********PREPARATI0N INIT************
 Cls
 Delayms 300
 
 Secs = 0
 
 
 Print At; 1, 2, "Top:  ", Dec2; Hrs, ":", Dec2; Mins, ":", Dec2; Secs
 Print At; 2, 1, "  Touche  Init  "
 
 repeat until initial = 0
 
 TempVal = Secs          'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Secs = TempVal

 TempVal = Mins          'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Mins = TempVal
                         
 TempVal = Hrs           'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Hrs = TempVal
   
 TempVal = Day           'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Day = TempVal
 
 TempVal = Date          'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Date = TempVal
 
 TempVal = Month         'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Month = TempVal
 
 TempVal = Year          'Repasse en BCD pour l'enregistrement du DS 1307
 GoSub BIN_TO_BCD
 Year = TempVal
 
 'Ecriture dans DS1307
   Busout 11010000, 0, [Secs, Mins, Hrs, day, Date, Month, Year, Ctrl]
   BStop
   Cls
   Delayms 400
   GoSub Main
 

